<?php

// Kto jest online

function kto_jest_online_upload_activity()
{
    kto_jest_online_cleanup();
    global $user_ID;
    if(kto_jest_online_real_ip() == $_SERVER['SERVER_ADDR'])
    {
        return;
    }
    else
    {
        global $wpdb;
        $kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
        $botname = kto_jest_online_get_botname($_SERVER['HTTP_USER_AGENT']);
        if(empty($user_ID))
        {
            $id = 'NULL';
        }
        else
        {
            $id = $wpdb->escape($user_ID);
        }
        $ip = kto_jest_online_real_ip();
        $sql = 'INSERT INTO ' . $kto_jest_online_table . ' (ip, user_id, botname, path, first_visit, last_visit, view_count) VALUES (\'' . $ip . '\', ' . $id . ', \'' . $botname . '\', \'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\' , '.time().', '.time().', 1) ON DUPLICATE KEY UPDATE path=\'' . $wpdb->escape($_SERVER['REQUEST_URI']) . '\', view_count=view_count+1, user_id=' . $id . ', last_visit = '.time().';';
        $wpdb->query($sql);
    }
}

function kto_jest_online_autor($username)
{
	global $wpdb;
	$check_online = $wpdb->get_results('SELECT t2.id AS id FROM '.$wpdb->prefix.'kto_jest_online AS t1 LEFT JOIN '.$wpdb->prefix.'users AS t2 ON t1.user_id = t2.id WHERE t2.user_login = \''.$wpdb->escape($username).'\';');
	if ($check_online) {
		$username = $username . ' ('.__('online', 'kto-jest-online').')';
	}
	return $username;
}

function kto_jest_online_real_ip()
{
    if((isset($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_X_FORWARDED_FOR'])) && long2ip(ip2long($_SERVER['HTTP_X_FORWARDED_FOR'])))
    {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }
    elseif(long2ip(ip2long($_SERVER['REMOTE_ADDR'])))
    {
        $ip = $_SERVER['REMOTE_ADDR'];
    }
    else
    {
        $ip = '127.0.0.1';
    }
    return $ip;
}

function kto_jest_online_get_botname($user_agent)
{
    $bots = array('Ahrefs' => 'AhrefsBot', 'MajesticSEO' => 'MJ12bot', 'SEOmoz' => 'rogerbot', 'Bing' => 'bingbot', 'Yandex' => 'Yandex', 'Baidu' => 'Baiduspider', 'Sitebot' => 'sitebot', 'LexxeBot' => 'LexxeBot', 'Ezooms' => 'Ezooms', 'Ichiro' => 'ichiro', 'Dotnetdotcom' => 'DotBot', 'AppEngine-Google' => 'AppEngine-Google', 'FacebookExternalHit' => 'facebookexternalhit', 'Alexa' => 'ia_archiver', 'All The Web' => 'FAST-WebCrawler', 'NetSprint' => 'NetSprint', 'All The Web' => 'crawler@fast', 'Altavista' => 'Scooter', 'Blekko' => 'Blekkobot', 'Ask.com' => 'Ask Jeeves/Teoma', 'DMOZ' => 'Robozilla', 'Exite' => 'Architext spider', 'Google' => 'Googlebot', ' Googlebot' => 'Googlebot', 'Google Images' => 'Googlebot-Image', 'AdsBot-Google' => 'AdsBot-Google', 'Googlebot-Mobile' => 'Googlebot-Mobile', 'Googlebot-Video' => 'Googlebot-Video', 'Googlebot-News' =>'Googlebot-News', 'Mediapartners-Google' => 'Mediapartners-Google', 'Infoseek' => 'InfoSeek sidewinder', 'Inktomi' => 'Slurp', 'Look Smart' => 'MantraAgent', 'Lycos' => 'Lycos_Spider', 'MLBot' => 'MLBot' ,'Bing' => 'MSNbot', 'Bing' => 'MSRBOT', 'Teoma' => 'Teoma_agent', 'Yahoo' => 'Yahoo Slurp', 'Web Crawler' => 'WebCrawler', 'Wise Nut' => 'ZyBorg');
    
	if(empty($user_agent))
    {
        $botname = '';
    }
    else
    {
        foreach($bots as $bot => $bot_match)
        {
            if(stristr($user_agent, $bot_match))
            {
                $botname = $bot;
                break;
            }
        }
    }
    return $botname;
}

function kto_jest_online_time_convert($seconds)
{
    $time = '';
    if($seconds > 3600)
    {
        $hours = ($seconds - ($seconds % 3600)) / 3600;
        $seconds = $seconds % 3600;
        $time .= $hours . ':';
    }
    $minutes = str_pad(($seconds - ($seconds % 60)) / 60, 2, 0, STR_PAD_LEFT);
    $seconds = str_pad($seconds % 60, 2, 0, STR_PAD_LEFT);
    $time .= $minutes . ':' . $seconds;
    return $time;
}

function kto_jest_online_cleanup()
{
    global $wpdb;
    $kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
    $sql = 'DELETE FROM ' . $kto_jest_online_table . ' WHERE ('.time().'-' . get_option('kto_jest_online_time_before_off') * 60 . ') > last_visit';
    $wpdb->query($sql);
}

?>