<?php

function indeksacja_add_custom_box() 
{
    add_meta_box( 
        'indeksacja_sectionid',
        __( '<img src="/wp-content/plugins/sbart-stats/icon.png" style="float:left;margin-right:5px"/>Stan indeksacji w Google', 'indeksacja_textdomain' ),
        'indeksacja_inner_custom_box',
        'post',
		'side',
		'high'
    );  
}

function indeksacja_inner_custom_box( $post ) 
{
	wp_nonce_field( plugin_basename( __FILE__ ), 'indeksacja_noncename' );
	global $wpdb;
	$stan_indeksacji = $wpdb->get_var( "SELECT google_info FROM $wpdb->posts WHERE ID = ".$post->ID);
	echo '<p><input type="checkbox" name="stan_indeksacji" value="1" '.stan_checbox($stan_indeksacji).'/> Powiadamiaj mnie o stanie indeksacji.</p>';
}

function indeksacja_save_postdata( $post_id ) 
{

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
		return;

	if ( !wp_verify_nonce( $_POST['indeksacja_noncename'], plugin_basename( __FILE__ ) ) )
		return;
		
	if ( 'page' == $_POST['post_type'] ) 
	{
		if ( !current_user_can( 'edit_page', $post_id ) )
			return;
	}
	else
	{
		if ( !current_user_can( 'edit_post', $post_id ) )
			return;
	}

	$google_info = $_POST['stan_indeksacji'];
	global $wpdb;
	$wpdb->update($wpdb->prefix."posts", array('google_info' => $google_info), array( 'ID' => $post_id));
}
?>